org.apache.xpath.functions

## Class Function

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.functions.Function

All Implemented Interfaces:
  java.io.Serializable, SourceLocator, ExpressionNode, XPathVisitable

Direct Known Subclasses:
  FuncCurrent, FuncExtFunction, FuncFalse, FuncLast, FuncPosition, FunctionOneArg, FuncTrue

    public abstract class Function
    extends Expression

This is a superclass of all XPath functions. This allows two ways for the class to be called. One method is that the super class processes the arguments and hands the results to the derived class, the other method is that the derived class may process it's own arguments, which is faster since the arguments don't have to be added to an array, but causes a larger code footprint.

See Also:
  Serialized Form
Usage:
  **For advanced use only**

### Constructor Summary

Constructors
Constructor and Description
`Function()`

### Method Summary

Methods
`void` `callArgVisitors(XPathVisitor visitor)` Call the visitors for the function arguments.
`void` `callVisitors(ExpressionOwner owner, XPathVisitor visitor)` This will traverse the heararchy, calling the visitor for each member.
`void` `checkNumberArgs(int argNum)` Check that the number of arguments passed to this function is correct.
`boolean` `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
`XObject` `execute(XPathContext xctxt)` Execute an XPath function object.
`void` `postCompileStep(Compiler compiler)` This function is currently only being used by Position() and Last().
`void` `setArg(Expression arg, int argNum)` Set an argument expression for a function.

### Methods inherited from class org.apache.xpath.Expression

`asIterator, asIteratorRaw, asNode, assertion, bool, canTraverseOutsideSubtree, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, fixupVariables, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Function

    public Function()

### Method Detail

#### setArg

    public void setArg(Expression arg,
              int argNum)
                throws WrongNumberArgsException

Set an argument expression for a function. This method is called by the XPath compiler.

Parameters:
  `arg` - non-null expression that represents the argument.
  `argNum` - The argument number index.
Throws:
  `WrongNumberArgsException` - If the argNum parameter is beyond what is specified for this function.

#### checkNumberArgs

    public void checkNumberArgs(int argNum)
                         throws WrongNumberArgsException

Check that the number of arguments passed to this function is correct. This method is meant to be overloaded by derived classes, to check for the number of arguments for a specific function type. This method is called by the compiler for static number of arguments checking.

Parameters:
  `argNum` - The number of arguments that is being passed to the function.
Throws:
  `WrongNumberArgsException`

#### execute

    public XObject execute(XPathContext xctxt)
                    throws TransformerException

Execute an XPath function object. The function must return a valid object.

Specified by:
  `execute` in class `Expression`
Parameters:
  `xctxt` - The execution current context.
Returns:
  A valid XObject.
Throws:
  `TransformerException`

#### callArgVisitors

    public void callArgVisitors(XPathVisitor visitor)

Call the visitors for the function arguments.

#### callVisitors

    public void callVisitors(ExpressionOwner owner,
                    XPathVisitor visitor)

Description copied from interface: `XPathVisitable`
This will traverse the heararchy, calling the visitor for each member. If the called visitor method returns false, the subtree should not be called.

Parameters:
  `owner` - The owner of the visitor, where that path may be rewritten if needed.
  `visitor` - The visitor whose appropriate method will be called.
See Also:
  `XPathVisitable.callVisitors(ExpressionOwner, XPathVisitor)`

#### deepEquals

    public boolean deepEquals(Expression expr)

Description copied from class: `Expression`
Compare this object with another object and see if they are equal, include the sub heararchy.

Specified by:
  `deepEquals` in class `Expression`
Parameters:
  `expr` - Another expression object.
Returns:
  true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
See Also:
  `Expression.deepEquals(Expression)`

#### postCompileStep

    public void postCompileStep(Compiler compiler)

This function is currently only being used by Position() and Last(). See respective functions for more detail.